﻿<AML>
 <Item type="Method" id="469D437E864B459F82589608DFF1A1AF" action="add">
  <comments>Fill the data for payment  that is purchase from supplier as Credit </comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			acc_APvendor_change
Created By/Company:		SolidCAD
Creation Date:		    2018/01/23
Description:
	-To solve that already Payment appear in Details List when filter Vendor,PaymentTerm and Option All Selected Receive.
	
Hooks:
	Type:	Form    :   Acc_AccountPayable
	Event:	acc_payment_term ( onBlur )
	Event:	acc_selected_all_payment ( onChange )
	Event:	acc_vendor ( onChange )
	
Revisions:
	Rev Date		Modified By			Description
	2018/07/16		Chan			Initial creation
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();

var _own_amt = "0";
var _acc_total_own = 0.00;
var _sourceid = "";
var payment_term_type = "";
var thisItem = document.thisItem;
var payment_details_count;
var _vendor_id = top.aras.getItemProperty(document.item, 'acc_vendor');
var acc_cash_account = top.aras.getItemProperty(document.item, 'acc_cash_account');
var acc_date = top.aras.getItemProperty(document.item, 'acc_date');
var acc_payment_term = top.aras.getItemProperty(document.item, 'acc_payment_term');
var acc_selected_all_payment = top.aras.getItemProperty(document.item, 'acc_selected_all_payment');

_sourceid = thisItem.getID();

// clear previous relationships data initially
var fRelationships = thisItem.fetchRelationships("Acc_AccountPayable_Detail");
var gRelationships = thisItem.getRelationships("Acc_AccountPayable_Detail");
var itemCount = gRelationships.getItemCount();
if (itemCount > 0) {
    for (var i = 0; i < itemCount; i++) {
        var item = gRelationships.getItemByIndex(i);
        thisItem.removeRelationship(item);
    }
}

tabbar = parent.relationships.relTabbar;
tabID = tabbar.GetTabId("AP Details");
parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);



var pur_invoice_qry = myInnovator.newItem("pop_purchase_invoice", "get");
if (_vendor_id !== "")

{
    pur_invoice_qry.setProperty("pop_vendor", _vendor_id);
}
pur_invoice_qry.setProperty("pop_own_amount", _own_amt);
pur_invoice_qry.setPropertyCondition("pop_own_amount", "ne");
pur_invoice_qry.setProperty("pop_invoice_status", "PAID");
pur_invoice_qry.setPropertyCondition("pop_invoice_status", "ne");
var logicalOR = pur_invoice_qry.newAND();
logicalOR.setProperty("pop_invoice_status", "Created");
logicalOR.setPropertyCondition("pop_invoice_status", "ne");
var logicalOR1 = logicalOR.newAND();
logicalOR1.setProperty("pop_invoice_status", "Approved");
logicalOR1.setPropertyCondition("pop_invoice_status", "ne");
pur_invoice_qry.setAttribute("orderBy", "pop_invoice_date asc ");
var l_acc_result = pur_invoice_qry.apply();

var l_acc_count = l_acc_result.getItemCount();
if (l_acc_count > 0) {
    for (var k = 0; k < l_acc_count; k++) {
        var acc_purinvoice = l_acc_result.getItemByIndex(k);
        var acc_purid = acc_purinvoice.getProperty("id", "");


        var acc_purno = acc_purinvoice.getProperty("pop_invoice_no", "");
        var pop_vendor = acc_purinvoice.getProperty("pop_vendor", "");
        var acc_purdate = acc_purinvoice.getProperty("pop_invoice_date", "");
        var oneDay = 24 * 60 * 60 * 1000; // hours*minutes*seconds*milliseconds
        var invoiceDate = new Date(acc_purdate);
        var todayDate = new Date(acc_date);
        var diffDays = Math.round(Math.abs((todayDate.getTime() - invoiceDate.getTime()) / (oneDay)));
        var acc_thirty = ">30 days";
        var acc_fortyfive = ">45 days";
        var acc_sixty = ">60 days";
        var acc_ninty = ">90 days";

        var arr_payment = acc_payment_term.split(",");
        var first_arr = arr_payment[0];
        var second_arr = arr_payment[1];

        first_arr = parseInt(first_arr);
        second_arr = parseInt(second_arr);
        if (acc_payment_term !== "") {
            if (diffDays >= first_arr && diffDays <= second_arr) {
                payment_term_type = acc_payment_term;
            } else {
                payment_term_type = "";
            }
        }

        if (payment_term_type === acc_payment_term) {
            var pop_id = acc_purinvoice.getProperty("id", "");
            var acc_puramount = acc_purinvoice.getProperty("pop_total_amount", "");
            var acc_purown = acc_purinvoice.getProperty("pop_own_amount", "");
            var acc_purpay = acc_purinvoice.getProperty("pop_paying", "");
            acc_puramount = parseFloat(acc_puramount);
            if (isNaN(acc_purpay)) {
                acc_purpay = 0;
            }
            var relationshipItem = myInnovator.newItem("Acc_AccountPayable_Detail", "add");
            if (acc_selected_all_payment == "1") {
                relationshipItem.setProperty("acc_pay_check", 1);
            } else {
                relationshipItem.setProperty("acc_pay_check", 0);
            }
            relationshipItem.setPropertyItem("acc_purchaseid", acc_purinvoice);
            relationshipItem.setProperty("acc_invoiceno", acc_purno);
            relationshipItem.setProperty("acc_date", acc_purdate);
            var currency_item = myInnovator.newItem("acc_Currency", "get");
            currency_item.setProperty("id", acc_purinvoice.getProperty("pop_currency", ""));
            currency_item.setPropertyCondition("id", "eq");
            currency_item = currency_item.apply();
            relationshipItem.setPropertyItem("acc_pop_currency", currency_item);
            relationshipItem.setProperty("acc_amount", acc_puramount);
            var bank_item = myInnovator.newItem("acc_AccountDetails", "get");
            bank_item.setProperty("id", acc_cash_account);
            bank_item.setPropertyCondition("id", "eq");
            bank_item = bank_item.apply();
            if (bank_item.getItemCount() > 0) {
                relationshipItem.setPropertyItem("acc_ap_cashbook", bank_item);
            }
            relationshipItem.setProperty("acc_exchange_amount", acc_puramount);
            relationshipItem.setProperty("acc_exchange_ownamount", acc_purown);

            //Check payment if create new payment
            var acc_account_payable = myInnovator.newItem("Acc_AccountPayable", "get");
            var acc_account_payable_items = acc_account_payable.apply();
            var payment_count = acc_account_payable_items.getItemCount();

            for (i = 0; i < payment_count; i++) {

                var acc_account_payable_item = acc_account_payable_items.getItemByIndex(i);
                var payment_id = acc_account_payable_item.getProperty("id", "");
                var state = acc_account_payable_item.getProperty("state", "");
                var test_count = acc_account_payable_item.getItemCount();

                var payable = myInnovator.newItem("Acc_AccountPayable_Detail", "get");
                payable.setProperty("SOURCE_ID", payment_id);
                payable.setPropertyCondition("SOURCE_ID", "eq");
                var gRelationships_data = payable.apply();
                var itemCount = gRelationships_data.getItemCount();
                if (itemCount > 0) {
                    for (var j = 0; j < itemCount; j++) {

                        var payment_details_item = gRelationships_data.getItemByIndex(j);

                        var payment_details_id = payment_details_item.getProperty("acc_purchaseid", "");
                        var duplicate_id_2 = payment_details_id;


                        if (payment_details_id === pop_id) {

                            var check_payable = myInnovator.newItem("Acc_AccountPayable_Detail", "get");
                            check_payable.setProperty("acc_purchaseid", pop_id);
                            check_payable.setPropertyCondition("acc_purchaseid", "eq");
                            var check_payable1 = check_payable.newAND();
                            check_payable1.setProperty("source_id", payment_id);
                            check_payable1.setPropertyCondition("source_id", "eq");
                            var payment_details_data = check_payable.apply();
                            payment_details_count = payment_details_data.getItemCount();

                            if (payment_details_count > 0) {

                                if (state === "POST TO GL")

                                {
                                    relationshipItem.setProperty("acc_payment", acc_purown);
                                    relationshipItem.setProperty("acc_owing", acc_purown);
                                }

                                if (state !== "POST TO GL") {
                                    for (var g = 0; g < payment_details_count; g++) {
                                        var payment_details_data_item = payment_details_data.getItemByIndex(g);

                                        var acc_payment = payment_details_data_item.getProperty("acc_payment", "");
                                        var f_acc_payment = parseFloat(acc_payment);

                                        var diff_acc_payment = acc_purown - f_acc_payment;
                                        acc_purown = diff_acc_payment;


                                    }
                                    relationshipItem.setProperty("acc_payment", diff_acc_payment);
                                    relationshipItem.setProperty("acc_owing", diff_acc_payment);

                                }

                            }
                        }

                        if (payment_details_id !== pop_id) {
                            var payable_payment = myInnovator.newItem("Acc_AccountPayable_Detail", "get");
                            payable_payment.setProperty("acc_purchaseid", pop_id);
                            payable_payment.setPropertyCondition("acc_purchaseid", "eq");
                            var payment_details_data = payable_payment.apply();
                            var payment_details_count = payment_details_data.getItemCount();

                            if (payment_details_count <= 0) {
                                relationshipItem.setProperty("acc_payment", acc_puramount);
                                relationshipItem.setProperty("acc_owing", acc_puramount);
                            }
                        }

                    }
                }



            }
            _acc_total_own = _acc_total_own + parseFloat(acc_purown);

            //*           
            if (payment_details_count === undefined) {
                diff_acc_payment = acc_puramount;
                relationshipItem.setProperty("acc_payment", diff_acc_payment);
                relationshipItem.setProperty("acc_owing", diff_acc_payment);
            }
            var vendor_item = myInnovator.newItem("Vendor", "get");
            vendor_item.setProperty("id", pop_vendor);
            vendor_item.setPropertyCondition("id", "eq");
            vendor_item = vendor_item.apply();
            if (vendor_item.getItemCount() > 0) {
                relationshipItem.setPropertyItem("acc_vendor", vendor_item);
            }
            relationshipItem.setProperty("source_id", _sourceid);

            if (diffDays > 30 && diffDays <= 45) {
                relationshipItem.setProperty("acc_info_date", acc_thirty);
            }
            if (diffDays > 45 && diffDays <= 60) {
                relationshipItem.setProperty("acc_info_date", acc_fortyfive);
            } else if (diffDays > 60 && diffDays <= 90) {
                relationshipItem.setProperty("acc_info_date", acc_sixty);
            } else if (diffDays > 90) {
                relationshipItem.setProperty("acc_info_date", acc_ninty);
            }
            if (acc_purown > 0) {
                document.thisItem.addRelationship(relationshipItem);
                document.thisItem.setAttribute("isDirty", "1");
            }
        }
    }
}
var tabbar = parent.relationships.relTabbar;
var tabID = tabbar.GetTabId("AP Details");
parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);
handleItemChange("acc_total_payment", _acc_total_own.toFixed(2));
if (acc_selected_all_payment == "1") {
    handleItemChange("acc_total_payment_amount", _acc_total_own.toFixed(2));
} else {
    handleItemChange("acc_total_payment_amount", "0.00");
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_APvendor_change</name>
 </Item>
</AML>